from django.core.paginator import Paginator

from DCbackend.utils.common import success, fail, pageData
from backend.Form.SupplierForm import SupplierForm
from backend.models import Supplier


class SupplierService:

    @staticmethod
    def Create(request):
        form = SupplierForm(request.POST)
        if form.is_valid():
            form.save()
            return success("成功")
        else:
            return fail(form.errors)

    @staticmethod
    def Update(request):
        data = Supplier.objects.filter(id=request.POST.get("id")).first();
        if data is not None:
            data.code = request.POST.get("code")
            data.name = request.POST.get("name")
            data.status = request.POST.get("status")
            data.save()
            return success("成功")
        else:
            return fail("更新供应商信息失败")

    @staticmethod
    def Info(request):
        info = Supplier.objects.filter(id=request.POST.get("id")).first()
        return success(SupplierService.getDetail(info))

    @staticmethod
    def Delete(request):
        Supplier.objects.filter(id=request.POST.get("id")).update(status=4)
        return success("成功")

    @staticmethod
    def getDetail(item: Supplier):
        return {
            "id": item.id,
            'code': item.code,
            'name': item.name,
            'createTime': item.create_time,
            'status': item.status
        }

    @staticmethod
    def Search(request):
        page = request.POST.get("page")
        pageSize = request.POST.get("pageSize")
        if page is None:
            page = 1
        if pageSize is None:
            pageSize = 1

        where = {}
        code = request.POST.get("code", '')
        if code:
            where["code__icontains"] = code

        name = request.POST.get("name", '')
        if name:
            where["name__icontains"] = name

        status = request.POST.get("status")
        if status:
            where['status'] = status

        paginator = Paginator(Supplier.objects.filter(**where).exclude(status=4).order_by("-id"),
                              pageSize)  # 每页显示10条数据
        page_obj = paginator.get_page(page)
        dataList = []
        for item in page_obj:
            info = SupplierService.getDetail(item)
            dataList.append(info)
        return success(pageData(page, pageSize, paginator.num_pages, paginator.count, dataList))
